
#import "USZipCodeView.h"
#import "wraps.h"

@implementation USZipCodeView

// Target Methods
- takeCode:sender
{
	[self setCode:[sender stringValue]];

	return ( self );
}


// Getter and Setter methods
- setCode:(const char *)str
{
	code = NXCopyStringBuffer(str);
	[self display];

	return ( self );
}

- setBkgColor:(NXColor)newColor
{
	bkgColor = newColor;
	[self display];
	return ( self );
}

- setLineColor:(NXColor)newColor
{
	lineColor = newColor;
	[self display];
	return ( self );
}

- takeLineColor:sender
{
	NXColor	newColor;

	newColor = [sender color];
	[self setLineColor:newColor];

	return ( self );
}

- takeBkgColor:sender
{
	NXColor	newColor;

	newColor = [sender color];
	[self setBkgColor:newColor];

	return ( self );
}

- (char *) code { return ( code ); }
- (NXColor) bkgColor { return ( bkgColor ); }
- (NXColor) lineColor { return ( lineColor ); }

// Overridden Methods
- initFrame:(const NXRect *)frameRect
{
	[super initFrame:frameRect];
	[self setCode:""];
	[self setLineColor:NX_COLORBLACK];
	[self setBkgColor:NX_COLORDKGRAY];

	return ( self );
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{
	(void) NXSetColor(bkgColor);
	(void) NXRectFill(&bounds);
	(void) NXSetColor(lineColor);
	(void) PSWPaintBars([self code]);

	return ( self );
}

- read:(NXTypedStream *)stream
{
	[super read:stream];

	(void) NXReadTypes(stream, "*", &code);
	(void) NXReadTypes(stream, "@", &source);
	bkgColor = NXReadColor(stream);
	lineColor = NXReadColor(stream);

	return ( self );
}

- write:(NXTypedStream *)stream
{
	[super write:stream];

	(void) NXWriteTypes(stream, "*", &code);
	(void) NXWriteTypes(stream, "@", &source);
	(void) NXWriteColor(stream, bkgColor);
	(void) NXWriteColor(stream, lineColor);

	return ( self );
}

// IB Protocol Methods
- (const char *)getInspectorClassName
{
    return "USZipCodeViewInspector";
}



@end